package cz.moneta.test.regression.backoffice.exevido.web.mailroom;

import cz.moneta.test.dsl.Harness;
import cz.moneta.test.dsl.util.credentials.Keys;
import cz.moneta.test.harness.annotations.JiraTestCase;
import cz.moneta.test.harness.annotations.TestCase;
import cz.moneta.test.harness.annotations.TestScenario;
import cz.moneta.test.harness.support.auth.Credentials;
import cz.moneta.test.harness.support.auth.Key;
import org.junit.jupiter.api.AfterEach;

import static cz.moneta.test.dsl.exevido.pages.NewOutgoingMessagePage.MESSAGE_ID_KEY;
import static cz.moneta.test.dsl.util.task.ufo.cb.CommercialTasks.JIRA_COMMENT_STORE_KEY;

@TestScenario(name = "Edit Template Test")
public class EditTemplate {

    @TestCase(name = "Edit Template Test")
    @JiraTestCase(id = "BOC-T8840")
    public void editTemplate(Harness harness, @Key(Keys.exevido.mailroom) Credentials credentials) {
        harness.withExevido()
                .openLoginPage()
                .then(harness.tasks().exevidoTasks().login().withCredentialsToMmb(credentials))
                .clickOutgoingMessages()
                .clickAllOutgoingMessages()
                .clickCreateNewOutgoingMessage()
                .clickPdfTemplateGenerating()
                .clickEmptyTemplateMmb()
                .storePdfViewerContent()
                .clickEditTemplate()
                .editTemplate()
                .clickSaveTemplate()
                .checkChangeOfPdfContent()
                .clickSaveConcept()
                .storeMessageId();
    }

    @AfterEach
    protected void tearDown(Harness harness) {
        harness.store(JIRA_COMMENT_STORE_KEY,
                "\nMessage ID: " + harness.get(MESSAGE_ID_KEY, true));
    }
}